<?php

include "options.php";

if(!isset($_SERVER["PHP_AUTH_USER"])) {
	header("WWW-Authenticate: Basic realm=\"" . $realm . "\"");
	header("HTTP/1.0 401 Unauthorized");
	echo "Error: authorisation required";
	exit;
}

$user=$_SERVER["PHP_AUTH_USER"];
$password=$_SERVER["PHP_AUTH_PW"];


if(!isset($_REQUEST["server"])) {
	$server=$default_server;
} else {
	$server=$_REQUEST["server"];
}

if(!isset($_REQUEST["share"])) {
	$share=$default_share;
} else {
	$share=$_REQUEST["share"];
}

if(in_array($server, $allowed_servers)) {
	$share_path= "//" . $server . "/" . $share;
} else {
	print "access to server $server denied";
	exit;
}

if(!isset($_REQUEST["dir"])) {
	$dir="/";
} else {
	$dir=$_REQUEST["dir"];
	if(!preg_match("/\/$/", $dir)) $dir .="/";
}

// do a file download
if(isset($_REQUEST["download"])) {
	$file=$_REQUEST["download"];
	$tmpfile=tempnam("/tmp", $file);

	shell_exec("$smbclient " 
		. escapeshellarg($share_path) . " "
		. escapeshellarg($password)
		. " -U " . escapeshellarg($user)
		. " -D " . escapeshellarg($dir)
		. " -d0 -c " 
		. escapeshellarg("get \"" . $file . "\" \"" . $tmpfile . "\""));

	$fd=fopen($tmpfile, "r");
	if(!$fd) {
		print "error opening tmp file for download";
		exit;
	}

	// send the file to the browser
	header("Content-type: application/octet-stream");
	header("Content-length: " . (string)(filesize($tmpfile)));
	header("Content-Disposition: inline;"
		. "filename=\"" . $file . "\";");
	fpassthru($fd);
	
	// delete the temporary file
	unlink($tmpfile);
	exit;
}

// handle file uploads
if(isset($_FILES["upload"])) {
	$upload_tmp=$_FILES["upload"]["tmp_name"];
	$upload_name=$_FILES["upload"]["name"];
	shell_exec("$smbclient " 
		. escapeshellarg($share_path) . " "
		. escapeshellarg($password)
		. " -U " . escapeshellarg($user)
		. " -D " . escapeshellarg($dir)
		. " -d0 -c " 
		. escapeshellarg("put \"" . $upload_tmp . "\" \"" . $upload_name . "\""));
}

// create directory
if(isset($_REQUEST["mkdir"])) {
	$mkdir=$_REQUEST["mkdir"];
	$mkdir=preg_replace("/\s/", "_", $mkdir);
	shell_exec("$smbclient " 
		. escapeshellarg($share_path) . " "
		. escapeshellarg($password)
		. " -U " . escapeshellarg($user)
		. " -D " . escapeshellarg($dir)
		. " -d0 -c " 
		. escapeshellarg("mkdir " . $mkdir));
}

// show directory listing
include "header.php";

print "<div class=\"files_main\">";
print "<h1>Directory of $dir on $share_path</h1>\n";

exec("$smbclient " 
	. escapeshellarg($share_path) . " "
	. escapeshellarg($password)
	. " -U " . escapeshellarg($user)
	. " -D " . escapeshellarg($dir)
	. " -d0 -c ls", $output);

for($i=0; $output[$i]; $i++) {
	if(!preg_match("/^\s\s/", $output[$i])) continue;

	$dir_entry=substr($output[$i], 0, -39);
	$dir_entry=trim($dir_entry);
	$dir_entry_display=$dir_entry;

	if($dir_entry==".") continue;
	if($dir_entry=="..") {
		if($dir=="/") {
			continue;
			//$dir_entry="";
			//$dir_prefix="/";
		} else {
			$dir_entry="";
			$dir_prefix=preg_replace("/(.*\/).*\//", "\\1", $dir);
		}
	} else {
		$dir_prefix=$dir;
	}

	$dir_type1=substr($output[$i], -36, -35);
	$dir_type2=substr($output[$i], -37, -36);
	$dir_type3=substr($output[$i], -38, -37);
	$dir_type4=substr($output[$i], -39, -38);

	if($dir_type1=="D"
		||$dir_type2=="D"
		||$dir_type3=="D"
		||$dir_type4=="D"
		) {
		$dir_list .= "<li class=\"dir_entry\">";
		$dir_list .= ""
			. "<a href=\"?dir=" 
			. urlencode($dir_prefix . $dir_entry)
			. "&server=" . urlencode($server)
			. "&share=" . urlencode($share)
			. "\">"
			. "<img src=\"dir.png\" />&nbsp;"
			. $dir_entry_display . "/" 
			. "</a>"
			. "</li>\n";
	} else {
		$file_list .= "<li class=\"file_entry\">";
		$file_list .= "<a href=\"?dir="
			. urlencode($dir_prefix)
			. "&download=" . urlencode($dir_entry)
			. "&server=" . urlencode($server)
			. "&share=" . urlencode($share)
			. "\">"
			. "<img src=\"file.png\" />&nbsp;"
			. $dir_entry_display . "</a>"
			. "</li>\n";
	}
}

print '<ul class="dir_list">';
print $dir_list;
print "</ul>\n";
print '<ul class="file_list">';
print $file_list;
print "</ul>\n";

// file upload form
print '<div class="upload_form">'
	. '<form enctype="multipart/form-data" action="" method="post">'
	. '<input type="hidden" name="MAX_FILE_SIZE" value="10000000" />'
	. 'Upload file'
	. '<input name="upload" type="file" />'
	. '<input type="submit" value="Upload File" />'
	. '</form>'
	. '</div>';

// directory create form
print '<div class="mkdir_form">'
	. '<form action="" method="post">'
	. 'Create directory'
	. '<input name="mkdir" type="text" />'
	. '<input type="submit" value="Create" />'
	. '</form>'
	. '</div>';

print "</div>"; //files_main

include "footer.php";
?>
